//+-------------------------------------------------------------------+
//|                                                  ZXPlus Alert.mq4 |
//|                                              Skype: skilful.coder |
//|                                      Email: skilful_coder@mail.ru |
//|                            Beknazarov Hasanboy, Uzbekistan  2015 |
//+-------------------------------------------------------------------+
#property copyright "skilful_coder ( from MQL5.com )  2015"
#property link "https://www.mql5.com/en/users/skilful_coder/portfolio"
#property version "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime      
#property indicator_color2 Magenta

double CrossUp[];
double CrossDown[];
input string Parmetrs_indicator         = "--< Indicator parameters >--";//Indicator parameters 
input string   _________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//___________XB4a Settingis
input int    RSI_period                 = 34;           //Period
input string    ________________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//___________XB4b Settingis
input int    RSI_period2                = 18;           //R Period
input int    RSI_period3                = 20;           //LSMA Period
input string     _______________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//___________XB4d Settingis
input int    RSI_period4                = 27;           //Period
input string           _________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//___________Alerts Settingis
input bool   alertsOn                   = 1;            //Alerts On
input bool   alertsNotify               = 1;            //Alerts Notify
input bool   alertsMessage              = 1;            //Alerts Message
input bool   alertsSound                = 1;            //Alerts Sound
input bool   alertsEmail                = 1;            //Alerts Email
input string            ________________="xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";//___________Arrow Settingis
input int    arrowsUpCode               = 233;          //Arrows Up Code
input int    arrowsDnCode               = 234;          //Arrows Dn Code
input int    arrowsUpSize               = 2;            //Arrows Up Size
input int    arrowsDnSize               = 2;            //Arrows Dn Size
input int    gap                        = 5;            //Gap
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
string   noting = "nothing";
datetime vaqt;
bool     alertsOnCurrent = 1; 
int      PipValue = 1;
double   point;       
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
   if((Bid<10 && _Digits==5)||(Bid>10 && _Digits==3)) { PipValue=10;}
   if((Bid<10 && _Digits==4)||(Bid>10 && _Digits==2)) { PipValue= 1;}
   point = PipValue*Point;
   SetIndexStyle(0, DRAW_ARROW, EMPTY,arrowsUpSize);
   SetIndexArrow(0, arrowsUpCode);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY,arrowsDnSize);
   SetIndexArrow(1, arrowsDnCode);
   SetIndexBuffer(1, CrossDown);
   return(0);}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  } 
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx     
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

    int limit, i;
    double RSI,RSI1,RSI2,RSI3,RSI4,RSI5,
    RSI6,RSI7,RSI0,RSI10,RSI20,RSI30,RSI40,
    RSI50,RSI60,RSI70;
    int counted_bars=IndicatorCounted();
    if(counted_bars<0) return(-1);
    if(counted_bars>0) counted_bars--;
    limit=Bars-counted_bars;   
    for(i = 0; i <= limit; i++) {   
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx         
      RSI   = iCustom(Symbol(),0,"5_star_ZXa_plus",RSI_period,1,i+1);
      RSI1  = iCustom(Symbol(),0,"5_star_ZXa_plus",RSI_period,0,i+1); 
      RSI0  = iCustom(Symbol(),0,"5_star_ZXa_plus",RSI_period,1,i+2);
      RSI10 = iCustom(Symbol(),0,"5_star_ZXa_plus",RSI_period,0,i+2);      
      RSI2  = iCustom(Symbol(),0,"5_Star_ZXb_Plus",RSI_period2,RSI_period3,2,i+1);  
      RSI3  = iCustom(Symbol(),0,"5_Star_ZXb_Plus",RSI_period2,RSI_period3,0,i+1);  
      RSI20 = iCustom(Symbol(),0,"5_Star_ZXb_Plus",RSI_period2,RSI_period3,2,i+2);  
      RSI30 = iCustom(Symbol(),0,"5_Star_ZXb_Plus",RSI_period2,RSI_period3,0,i+2);     
      RSI4  = iCustom(Symbol(),0,"5_Star_ZXd_Plus",RSI_period4,1,i+1); 
      RSI5  = iCustom(Symbol(),0,"5_Star_ZXd_Plus",RSI_period4,2,i+1);  
      RSI40 = iCustom(Symbol(),0,"5_Star_ZXd_Plus",RSI_period4,1,i+2); 
      RSI50 = iCustom(Symbol(),0,"5_Star_ZXd_Plus",RSI_period4,2,i+2);
      RSI6  = iCustom(Symbol(),0,"5_Star_HeikenAshiZoneTrade",0,i+1); 
      RSI7  = iCustom(Symbol(),0,"5_Star_HeikenAshiZoneTrade",5,i+1); 
      RSI60 = iCustom(Symbol(),0,"5_Star_HeikenAshiZoneTrade",0,i+2); 
      RSI70 = iCustom(Symbol(),0,"5_Star_HeikenAshiZoneTrade",5,i+2);
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx  
      if ((RSI != EMPTY_VALUE && RSI2 != EMPTY_VALUE && RSI4 !=0 && RSI6 > RSI7) && !(RSI0 != EMPTY_VALUE && RSI20 != EMPTY_VALUE && RSI40 !=0 && RSI60 > RSI70)) 
         {                 
          CrossUp[i] = (iLow(NULL,0,i) - gap * point);
         }
      if ((RSI1 != EMPTY_VALUE && RSI2 == EMPTY_VALUE && RSI5 !=0 && RSI7 > RSI6) && !(RSI10 != EMPTY_VALUE && RSI20 == EMPTY_VALUE && RSI50 !=0 && RSI70 > RSI60))
         {         
          CrossDown[i] = (iHigh(NULL,0,i) + gap * point);     
         }}                      
   Qongir();
   return(0);
 }
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void Qongir() {
   int shift;
   if (alertsOn){
      if (alertsOnCurrent) shift = 0;
      else shift = 1;
      if (CrossUp[shift] != EMPTY_VALUE && CrossUp[shift + 1] == EMPTY_VALUE) blok(shift, "Long");
      if (CrossDown[shift] != EMPTY_VALUE && CrossDown[shift + 1] == EMPTY_VALUE) blok(shift, "Short");}}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void blok(int ichki, string ttttt) {
   string rrrrr;
   if (noting != ttttt || vaqt != iTime(NULL,0,ichki)) {
      noting = ttttt;
      vaqt = iTime(NULL,0,ichki);
      rrrrr = StringConcatenate(Symbol(), " ",TF2Str()," at ",TimeToStr(TimeLocal(), TIME_SECONDS) , "  ", ttttt);
      if (alertsMessage) Alert(rrrrr);
      if (alertsNotify) SendNotification(rrrrr);
      if (alertsEmail) SendMail(StringConcatenate(Symbol(), " 5 Star ZXplus Signal "), rrrrr);
      if (alertsSound) PlaySound("news.wav");}}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//-----------------------------------------------------------------------------
// function: TF2Str()
// Description: Convert time-frame to a string
//-----------------------------------------------------------------------------
string TF2Str() {
  switch(Period()) {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN");
   }
  return((string)0);
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
